#!/bin/sh

DISTDIR=$1
MODULE_DEL_LIST="serialmodule"
TYPE_DEL_LIST="videowallcontroltype"
EXAMPLE_GRAPHS="example1 example2 example3 gephexwin32"
STUFF_TO_COPY="../bin ../dlls ../examples ../doc"

STUFF_TO_RECODE="AUTHORS COPYING NEWS README BUGS"

CONFIG_FILE="../data/gephexw.conf.default"

if test -e $DISTDIR
then
  echo "Dir $DISTDIR already exists!"
  exit 1
fi

mkdir $DISTDIR

echo "- Copying stuff..."
for i in $STUFF_TO_COPY; do
    echo "  * $i"
    cp -r $i $DISTDIR
done

echo "- Recoding stuff..."
for i in $STUFF_TO_RECODE; do
    echo "  * ../$i"
    cat ../$i | recode latin1..ibmpc > $DISTDIR/$i
done

echo "- Installing config file '$CONFIG_FILE'"
cat $CONFIG_FILE | recode latin1..ibmpc > $DISTDIR/gephex.conf


echo "- Installing examples..."
mkdir $DISTDIR/graphs
for i in $EXAMPLE_GRAPHS; do
    echo "  * $i"
    cp $DISTDIR/examples/graphs/$i $DISTDIR/graphs
done


echo "- Removing $MODULE_DEL_LIST..."
for i in $MODULE_DEL_LIST; do
    rm -f $DISTDIR/dlls/modules/$i.dll
done

echo "- Removing $TYPE_DEL_LIST..."
for i in $TPYE_DEL_LIST; do
    rm -f $DISTDIR/dlls/types/$i.dll
done

echo "- Removing arch folders and Makefiles..."
find $DISTDIR -name "{arch}" -o -name ".arch-ids" -o -name "Makefile.am" | xargs rm -rf

LIB_ADD_PATH='c:/gphx_dist_data/extra_dlls/'
echo "- Copying * from $LIB_ADD_PATH to bin dir"
cp $LIB_ADD_PATH/* $DISTDIR/bin

DOCU_PATH='c:/gphx_dist_data/doc'
echo "- Copying Documentation: $DOCU_PATH"
rm -rf $DISTDIR/doc/*
cp -r $DOCU_PATH/* $DISTDIR/doc/

#UPX='e:/upx124w/upx.exe'
#echo "- Compressing with upx..."
#$UPX -9 $DISTDIR/bin/*.exe
#$UPX -9 $DISTDIR/bin/*.dll
#$UPX -9 $DISTDIR/dlls/modules/*.dll
#$UPX -9 $DISTDIR/dlls/types/*.dll

